// Generated by CoffeeScript 2.0.2
var _snake_case, clone, is_object, is_object_literal, merge, mutate,
  _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

module.exports = module.exports.merge = merge = function() {
  return mutate({}, ...arguments);
};

module.exports.clone = clone = function(target, source = {}) {
  if (Array.isArray(target)) {
    return target.map(function(element) {
      return module.exports.clone(element, _extends({}, source, {
        level: (source.level || 0) + 1
      }));
    });
  } else if (target && typeof target === 'object') {
    return module.exports.mutate({}, target);
  } else {
    return target;
  }
};

module.exports.mutate = mutate = function() {
  var i, j, name, ref, source, target;
  target = arguments[0];
  for (i = j = 1, ref = arguments.length; 1 <= ref ? j < ref : j > ref; i = 1 <= ref ? ++j : --j) {
    source = arguments[i];
    if (is_object_literal(target) && is_object_literal(source)) {
      for (name in source) {
        target[name] = mutate(target[name], source[name]);
      }
    } else if (source !== void 0) {
      target = source;
    }
  }
  return target;
};

module.exports.snake_case = function(source, snake_case = true) {
  var name, src, target, u;
  target = {};
  if (is_object_literal(source)) {
    u = typeof snake_case === 'number' && snake_case > 0 ? snake_case - 1 : snake_case;
    for (name in source) {
      src = source[name];
      if (snake_case) {
        name = _snake_case(name);
      }
      target[name] = module.exports.snake_case(src, u);
    }
  } else {
    target = source;
  }
  return target;
};

_snake_case = function(str) {
  return str.replace(/([A-Z])/g, function(_, match, index) {
    return '_' + match.toLowerCase();
  });
};

module.exports.is_object = is_object = function(obj) {
  return obj && typeof obj === 'object' && !Array.isArray(obj);
};

module.exports.is_object_literal = is_object_literal = function(obj) {
  var test;
  test = obj;
  if (typeof obj !== 'object' || obj === null) {
    return false;
  } else {
    while (!false) {
      if (Object.getPrototypeOf(test = Object.getPrototypeOf(test)) === null) {
        break;
      }
    }
    return Object.getPrototypeOf(obj) === test;
  }
};
